{zamysel: porozhd. matrits, sootv. el-tam simm. 32-kh tochechn. grupp
  simm. kr-llov; tau - chtoby ispol`z. gotov. proc. PROIZV;
  >-vo grupp ne dodelano, a v imejushchikhs`a m.b. oshibki, nestandartn.
  numerats. el-tov i t.p.
  Vs`o zadajotsa v bazise, sv`az. s minim. transl. Poka ne pokaz., chto
  nel`z`a schitat`, chto v obratn. reshotke dejstv. te zhe matritsy,
  iskhodim iz togo, chto oni tam dejstv.
}
{vyjasneno dl`a grupp s os`ami C3 (kak dl`a C6 - poka ne razbir.):
  (1) dl`a romboedr. grupp v Internat. Tables dajutsa polozh. kak v
    geksag., tak i v romboedr. os`akh; nado zdes` tozhe predusm.
    oba var-ta i parametr podprogramm, zad. vybor odnogo iz var-tov;
  (2) vozm. 2 var-ta: (a) C2 - po transl., perp. C3, i/ili m -
    perp. takim transl.; (b) C2 - perp. takim transl., m - po nim.
    Eto zapis. po tipam P3 2/m 1 i P3 1 2/m. T.k. u nas ispol`z.
    orientats. el-tov simm. otnos. transl`atsij,
  (3) SiO2 - prover. prostr. gruppu.
  (4) vmesto obr. resh. - nel`z`a li kazhd. vekt. obr. resh.
    vyrazit` cherez vekt. proizv. vektorov pr`amoj, i togda simm.-ekv.
    porozhd. po tipu x x y -> Ax x Ay ?
}

 type oper=record a:matr3; tau:vect3; end; {oper. simm.: x -> Ax+tau}
 var n_oper:integer; ope:array[1..48] of oper; {operatsii tochechnoj gruppy}

 procedure proizv(var c,a_,b:oper); var i,j,k:integer; {B(Ax+a)+b=(BA)x+(Ba+b)}
 begin
  for i:=1 to 3 do begin for k:=1 to 3 do begin
   c.a[i,k]:=0; for j:=1 to 3 do c.a[i,k]:=c.a[i,k]+b.a[i,j]*a_.a[j,k];
  end end;
  for i:=1 to 3 do begin
   c.tau[i]:=b.tau[i]; for j:=1 to 3 do c.tau[i]:=c.tau[i]+b.a[i,j]*a_.tau[j];
   while c.tau[i]<0 do c.tau[i]:=c.tau[i]+1;
   if int(c.tau[i])>0 then c.tau[i]:=frac(c.tau[i]);
  end;
 end;

{ -------- trikl. -------- }

 procedure point_1 {C1};
 begin
  n_oper:=1;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
 end;

 procedure point_1_ {Ci};
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1);
 end;

{ -------- monokl.; b perp. ac -------- }

 procedure point_2 {C2};
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,1,0, 0,0,-1);
 end;

 procedure point_m {Cs};
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, 1,0,0, 0,-1,0, 0,0,1);
 end;

 procedure point_2_m {C2h}; 
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1);
 end;

 { -------- ortorombich. -------- }

 procedure point_222 {D2};
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a,1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[3].a,-1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[4].a,-1,0,0, 0,-1,0, 0,0,1);
 end;

 procedure point_mm2 {C2v};
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,1);
  initmatr(ope[3].a, -1,0,0, 0,1,0, 0,0,1); 
  initmatr(ope[4].a, 1,0,0, 0,-1,0, 0,0,1); 
 end;

 procedure point_mmm {D2h};
 begin
  n_oper:=8;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1);
  initmatr(ope[4].a, 1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[5].a, -1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[6].a, 1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[7].a, -1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[8].a, -1,0,0, 0,-1,0, 0,0,1);
 end;

{ -------- tetrag. -------- }

 procedure point_422 {D4};
 begin
  n_oper:=8;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,1);
  initmatr(ope[3].a, 0,1,0, 1,0,0, 0,0,-1);
  initmatr(ope[4].a, 0,-1,0, -1,0,0, 0,0,-1);
  initmatr(ope[5].a, -1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[6].a, 1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[7].a, 0,-1,0, 1,0,0, 0,0,1);
  initmatr(ope[8].a, 0,1,0, -1,0,0, 0,0,1);
 end;

 procedure point_4_2m {D2d};
 begin
  n_oper:=8;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,1);
  initmatr(ope[3].a, 0,-1,0, 1,0,0, 0,0,-1);
  initmatr(ope[4].a, 0,1,0, -1,0,0, 0,0,-1);
  initmatr(ope[5].a, -1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[6].a, 1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[7].a, 0,1,0, 1,0,0, 0,0,1); 
  initmatr(ope[8].a, 0,-1,0, -1,0,0, 0,0,1);
 end;

{ -------- geksag. -------- }

 procedure point_3 {C3};
  var c3,c2:oper; i:integer;
 begin
  n_oper:=3;
  initmatr(c3.a, 0,-1,0, 1,-1,0, 0,0,1); initvect(c3.tau,0,0,0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],c3);
 end;

 procedure point_32 {D3};
  var c3,c2:oper; i:integer;
 begin
  n_oper:=6;
  initmatr(c3.a, 0,-1,0, 1,-1,0, 0,0,1); initvect(c3.tau,0,0,0);
  initmatr(c2.a, 1,-1,0, 0,-1,0, 0,0,-1); initvect(c2.tau,0,0,0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],c3);
  for i:=4 to 6 do proizv(ope[i],c2,ope[i-3]);
 end;

 procedure point_6_mmm {D6h};
  var c6,m,sh:oper; i:integer;
 begin
  n_oper:=24;
  initmatr(c6.a, 1,-1,0, 1,0,0, 0,0,1); initvect(c6.tau,0,0,0);
  initmatr(m.a, 0,1,0, 1,0,0, 0,0,1); initvect(m.tau,0,0,0);
  initmatr(sh.a, 1,0,0, 0,1,0, 0,0,-1); initvect(sh.tau,0,0,0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],c6);
  for i:=7 to 12 do proizv(ope[i],m,ope[i-6]);
  for i:=13 to 24 do proizv(ope[i],sh,ope[i-12]);
 end;

 { ----- romboedr.; bazis - elem. transl. romboedra ----- }

 procedure point_3m {C3v};
  var s6,b:oper; i:integer;
 begin
  n_oper:=6;
  initmatr(s6.a, 0,0,1, 1,0,0, 0,1,0); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],s6);
  for i:=4 to 6 do proizv(ope[i],b,ope[i-3]);
 end;

 procedure point_3_m {D3d};
  var s6,b:oper; i:integer;
 begin
  n_oper:=12;
  initmatr(s6.a, 0,-1,0, 0,0,-1, -1,0,0); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  for i:=7 to 12 do proizv(ope[i],b,ope[i-6]);
 end;

{ ----- kub. ----- }

 procedure point_23 {T};
  var i:integer;
 begin
  n_oper:=12;
  {E}
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  { 3 C4^2 }
  initmatr(ope[2].a,  1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[3].a, -1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[4].a, -1,0,0, 0,-1,0, 0,0,1);
  { 8 C3 }
  initmatr(ope[5].a, 0,1,0, 0,0,1, 1,0,0);
  initmatr(ope[6].a, 0,1,0, 0,0,-1, -1,0,0);
  initmatr(ope[7].a, 0,-1,0, 0,0,1, -1,0,0);
  initmatr(ope[8].a, 0,-1,0, 0,0,-1, 1,0,0);
  initmatr(ope[9].a, 0,0,1, 1,0,0, 0,1,0);
  initmatr(ope[10].a, 0,0,1, -1,0,0, 0,-1,0);
  initmatr(ope[11].a, 0,0,-1, 1,0,0, 0,-1,0);
  initmatr(ope[12].a, 0,0,-1, -1,0,0, 0,1,0);
  for i:=1 to 12 do initvect(ope[i].tau,0,0,0)
 end;

 procedure point_m3 {Th};
  var b:oper; i:integer;
 begin
  point_23;
  initmatr(b.a, -1,0,0, 0,-1,0, 0,0,-1); {i}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=24;
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
 end;

 procedure point_432 {O};
  var b:oper; i:integer;
 begin
  point_23;
  initmatr(b.a, -1,0,0, 0,0,1, 0,1,0); {1 iz 6 C2}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=24;
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
 end;

 procedure point_4_3m {Td};
  var b:oper; i:integer;
 begin
  point_23;
  initmatr(b.a, 1,0,0, 0,0,-1, 0,-1,0); {sigma d}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=24;
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
 end;

 procedure point_m3m {Oh};
  var b:oper; i:integer;
 begin
  point_4_3m;
  initmatr(b.a, -1,0,0, 0,-1,0, 0,0,-1); {i}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=48;
  for i:=25 to 48 do proizv(ope[i],b,ope[i-24]);
 end;

